Count New String 牛客第四场C题解

题解
对给出的方程式进行几次递推后可以得到答案就是一次变化得到的所有字符串的不同的子串种类数。很显然这个转换后的问题是广义后缀自动机的模板题。
不过我们不可以一次次处理出所有的这样的后缀再一个个地插入到广义后缀自动机里面求解答案,那样的做法显然会 tle。
这时候注意到题目说字符集只有 a 到 j 这10个字母,那么最坏的情况这些字符串就是:
aaabbb
aaabbbccc
这样的形式,最多是10N。
我们从右往左枚举字符串的每一个字符,然后寻找其右边第一个大于自己的字符,然后当前字符到第一个大于自己的字符中间的字符串插入到广义sam中得到的贡献就是这串字符串+后缀到广义sam中的贡献,因为不同的字符串后面加上一串字符后还是和之前不一样的子串。
这部分可以使用类似单调栈的方法来求解。

#include 
using namespace std;
typedef long long ll;
const int maxn=3e6+10;
char s[maxn], t[maxn], rec[maxn];
 
struct Trie 
{
    int O, c[maxn], fa[maxn], tr[maxn][10];
    int pos[maxn];
 
    Trie() 
	{
        O = 1;
    } 
    void insert(int k, char ch[], int id) 
	{
        int p = id;
        for (int i = 1; ch[i]; ++i) 
		{
            int rec = ch[i] - 'a';
            if (!tr[p][rec])tr[p][rec] = ++O, fa[O] = p, c[O] = rec;
            p = tr[p][rec];
        }
        pos[k] = p;
    }
}T1;
 
struct Suffix_Automaton 
{
    int O, pos[maxn], link[maxn], len[maxn], trans[maxn][10];
    queue<int> Q;
    Suffix_Automaton() 
	{
        O = 1;
    }
    int insert(int ch, int last) 
	{
        int x, y, z = ++O, p = last;
        len[z] = len[last] + 1;
        while (p && !trans[p][ch])trans[p][ch] = z, p = link[p];
        if (!p)link[z] = 1;
        else {
            x = trans[p][ch];
            if (len[p] + 1 == len[x])link[z] = x;
            else {
                y = ++O;
                len[y] = len[p] + 1;
                for (int i = 0; i < 10; ++i)trans[y][i] = trans[x][i];
                while (p && trans[p][ch] == x)trans[p][ch] = y, p = link[p];
                link[y] = link[x], link[z] = link[x] = y;
            }
        }
        return z;
    }
 
    void build() 
	{
        for (int i = 0; i < 10; ++i)if (T1.tr[1][i])Q.push(T1.tr[1][i]);
        pos[1] = 1;
        while (!Q.empty()) {
            int x = Q.front();
            Q.pop();
            pos[x] = insert(T1.c[x], pos[T1.fa[x]]);
            for (int i = 0; i < 10; ++i)if (T1.tr[x][i])Q.push(T1.tr[x][i]);
        }
    }
 
    void solve() 
	{
        ll ans = 0;
        for (int i = 2; i <= O; ++i)ans += len[i] - len[link[i]];
        printf("%lld\n", ans);
    }
} SAM;
 
int main() 
{
    scanf("%s",s+1);
    int n=strlen(s+1);
	int len=0;int cnt=0;
    t[++len]=s[n];
    T1.pos[n+1]=1;
    T1.insert(n,t,1);
    for(int i=n-1;i;i--) 
	{
        cnt=0;
        rec[++cnt]=s[i];
        int k=i+1;
        for(int j=len;j>=1;j--) 
		{
            if(s[i]<=t[j]) break;
            if(s[i]>t[j]) 
			{
                t[j]=s[i];
                rec[++cnt]=s[i];
                ++k;
            }
        }
        rec[cnt+1]='\0';
        T1.insert(i,rec,T1.pos[k]);
        t[++len]=s[i];
    }
    SAM.build();
    SAM.solve();
    return 0;
}

你可能感兴趣的:(刷题记录,题解,字符串)